#ifndef __DB_CRCTAB_H__
#define __DB_CRCTAB_H__

#include "../common/db_types.h"

#ifdef XGSAVR
#include <avr/pgmspace.h>
extern const uint16_t PROGMEM crctab[];
#define crctabget(i)	pgm_read_word(&crctab[i])
#else
extern const uint16_t crctab[];
#define crctabget(i)	crctab[i]
#endif

/*
 * updcrc macro derived from article Copyright (C) 1986 Stephen Satchell. 
 *  NOTE: First argument is referenced twice.
 *        Second argument must be in range 0 to 255.
 * 
 * Programmers may incorporate any or all code into their programs, 
 * giving proper credit within the source. Publication of the 
 * source routines is permitted so long as proper credit is given 
 * to Stephen Satchell, Satchell Evaluations and Chuck Forsberg, 
 * Omen Technology.
 */

#define updcrc(crc,ch) (crctabget(((crc) >> 8) & 0xff) ^ ((crc) << 8) ^ (ch))

#endif
